import { fetchOperatorList } from '@/api/base/index';

const FETCH_OPERATOR_LIST = 'FETCH_OPERATOR_LIST';
const FETCH_STATE = 'FETCH_STATE';

const state = () => ({
  list: [],
  fetching: false,
});

const getters = {
  operatorOptionList: state => state.list,
};

const actions = {
  fetchOperatorList({ state, commit }) {
    if (state.fetching) return;
    commit(FETCH_STATE, true);
    return fetchOperatorList().then(res => {
      const list = res.data;
      commit(FETCH_OPERATOR_LIST, list);
      commit(FETCH_STATE, false);
    });
  },
};

const mutations = {
  [FETCH_OPERATOR_LIST](state, list) {
    state.list = list;
  },
  [FETCH_STATE](state, fetching) {
    state.fetching = fetching;
  },
};

export default {
  namespaced: true,
  state,
  getters,
  actions,
  mutations,
};
