import { mapGetters, mapActions } from 'vuex';
import store from './store';

export default {
  created() {
    store.install(this.$store);
  },
  mounted() {
    if (!this.operatorOptionList.length) {
      this.fetchOperatorList();
    }
  },
  computed: {
    ...mapGetters('OperatoerOption', ['operatorOptionList']),
  },
  methods: {
    ...mapActions('OperatoerOption', ['fetchOperatorList']),
    getOperatorName(id) {
      let item = this.operatorOptionList.find(
        ServiceType => ServiceType.id === id
      );
      if (item) {
        return item.operateName;
      } else {
        return '';
      }
    },
  },
};
