import {
  formatDate,
  parseTime,
  getFilters,
  formatePhone,
  allowLetterNumber,
  formatterMoneyToDouble,
} from '@/utils/index';
import rymUi from 'rym-element-ui';
import 'rym-element-ui/lib/rymUi.css';

import HeaderImg from '../components/HeaderImg/HeaderImg.vue';
import UserWithContent from '../components/UserCard/UserWithContent.vue';
import UserCard from '../components/UserCard/UserCard.vue';
import UserInfo from '../components/UserCard/UserInfo.vue';
import UserDialog from '../components/Dialog/UserDialogWrap';

import AreaSelect from '../components/input/AreaSelect/index';
import ServiceTypeSelect from '../components/input/ServiceTypeSelect/index';
import GiveTypeSelect from '../components/input/GiveTypeSelect.vue';
import BaseDataSelect from '../components/input/BaseDataSelect/index';
import OperatorSelect from '../components/input/OperatorSelect/index';
import BeansSelect from '../components/input/BeanTypeSelect/index';
import ImageUploader from '../components/input/ImageUploader/index';

const extendVue = Vue => {
  Vue.use(rymUi);
  Vue.prototype.$formatDate = formatDate;
  Vue.prototype.$parseTime = parseTime;
  Vue.prototype.$formatePhone = formatePhone;
  Vue.prototype.$getFilters = getFilters;
  Vue.prototype.$allowLetterNumber = allowLetterNumber;
  Vue.prototype.$formatterMoneyToDouble = formatterMoneyToDouble;

  Vue.component('UserCard', UserCard);
  Vue.component('UserInfo', UserInfo);
  Vue.component(UserWithContent.name, UserWithContent);
  Vue.component(UserDialog.name, UserDialog);
  Vue.component(HeaderImg.name, HeaderImg);

  // input
  Vue.component(AreaSelect.name, AreaSelect);
  Vue.component(BaseDataSelect.name, BaseDataSelect);
  Vue.component(ServiceTypeSelect.name, ServiceTypeSelect);
  Vue.component(GiveTypeSelect.name, GiveTypeSelect);
  Vue.component(OperatorSelect.name, OperatorSelect);
  Vue.component(BeansSelect.name, BeansSelect);
  Vue.component(ImageUploader.name, ImageUploader);
};

export default extendVue;
